Index: main/trunk/gli/classes/dictionary_fr.properties
===================================================================
--- main/trunk/gli/classes/dictionary_fr.properties	(revision 33114)
+++ main/trunk/gli/classes/dictionary_fr.properties	(revision 33115)
@@ -171,5 +171,5 @@
 CDM.IndexManager.Indexes:Index attribuÃ©s
 CDM.IndexManager.Level:Niveau d'indexation :
-CDM.IndexManager.Level_Tooltip:Le niveau du document sur lequel construire l'index
+CDM.IndexManager.Level_Tooltip:UnitÃ© de texte sur laquelle est basÃ©e l'index
 CDM.IndexManager.Add_All:Ajouter tout
 CDM.IndexManager.Add_All_Tooltip:Ajout d'un index distinct pour chacune des sources
@@ -1015,5 +1015,4 @@
 Preferences.Connection.Proxy_Host_Missing:Entrer une valeur pour au moins un hÃŽte proxy ou dÃ©sactiver "Utiliser la connexion Proxy" dans lâonglet Connexion
 Preferences.Connection.Proxy_Port:Port:
-
 Preferences.Connection.Servlet:Servlet:
 Preferences.Connection.Servlet_Tooltip:Servlet Ã  utiliser pour afficher votre site
@@ -1030,5 +1029,5 @@
 Preferences.General.Interface_Language:Langue d'interface
 Preferences.General.Interface_Language_Tooltip:SÃ©lectionner la langue que vous voulez utiliser pour l'interface et ses commandes,
-Preferences.General.Restart_Required:GLI doit Ãªtre redÃ©marrÃ© pour mettre Ã  jour la langue de son interface.
+Preferences.General.Restart_Required:GLI va redÃ©marrer maintenant afin de charger la nouvelle langue de son interface.
 Preferences.General.Manual_Restart_Required:Veuillez redÃ©marrer GLI afin de que les modifications prennent effet.
 Preferences.General.Show_File_Size:Montrer les tailles des fichiers
Index: main/trunk/greenstone3/web/WEB-INF/classes/ServiceRack_fr.properties
===================================================================
--- main/trunk/greenstone3/web/WEB-INF/classes/ServiceRack_fr.properties	(revision 33114)
+++ main/trunk/greenstone3/web/WEB-INF/classes/ServiceRack_fr.properties	(revision 33115)
@@ -103,4 +103,29 @@
 param.rnpw:veuillez retaper le nouveau mot de passe
 
+## Authentication errors
+auth.error.not_logged_in:Vous devez Ãªtre connectÃ© pour accÃ©der Ã  cette page.
+auth.error.admin_not_logged_in:Vous devez Ãªtre connectÃ© en tant qu'administrateur pour accÃ©der Ã  cette page.
+auth.error.could_not_get_user_info:Il y a eu une erreur en rÃ©cupÃ©rant lâinformation de lâutilisateur.
+auth.error.username_not_specified:Aucun nom dâutilisateur nâa Ã©tÃ© spÃ©cifiÃ©.
+auth.error.user_not_found:L'utilisateur demandÃ© n'a pas Ã©tÃ© trouvÃ© dans la base de donnÃ©es.
+auth.error.invalid_username:Le nom d'utilisateur spÃ©cifiÃ© n'Ã©tait pas valide (il doit comporter entre 2 et 30 caractÃšres et contenir seulement les caractÃšres a-z, A-Z, 0-9 et _ ou .).
+auth.error.no_password:Aucun mot de passe nâa Ã©tÃ© entrÃ©.
+auth.error.password_too_short:Le mot de passe que vous avez entrÃ© Ã©tait trop court (3 caractÃšres minimum).
+auth.error.password_too_long:Le mot de passe que vous avez entrÃ© Ã©tait trop long (64 caractÃšres maximum).
+auth.error.password_illegal_chars:Le mot de passe que vous avez entrÃ© contient des caractÃšres illÃ©gaux (seuls les caractÃšres ascii sont valides).
+auth.error.incorrect_password:Le mot de passe spÃ©cifiÃ© est incorrect.
+auth.error.user_already_exists:Ce nom dâutilisateur existe dÃ©jÃ Â ; veuillez en choisir un autre.
+auth.error.add_user_error:Il y a eu une erreur en ajoutant cet utilisateur Ã  la base de donnÃ©es.
+auth.error.remove_user_error:Il y a eu une erreur lors de la suppression de cet utilisateur de la base de donnÃ©es.
+auth.error.captcha_failed:Il y a eu un problÃšme pour vous vÃ©rifier avec reCAPTCHA
+auth.error.captcha_missing:L'information du captcha est manquante.
+auth.error.connection_failed:Il y a eu un problÃšme de connexion au site web de reCAPTCHA. Veuillez contacter l'administrateur de votre bibliothÃšque.
+auth.error.not_authorised:Vous n'Ãªtes pas autorisÃ© Ã  accÃ©der Ã  cette page.
+auth.error.missing_params:ParamÃštres obligatoires manquants : nom d'utilisateur, ancien mot de passe ou nouveau mot de passe
+auth.error.something_wrong:DÃ©solÃ©. Quelque chose a mal tournÃ© et je ne suis pas sÃ»r de la page que vous voulez.
+auth.success.account_settings:Vous avez modifiÃ© vos informations avec succÃšs.
+auth.success.edit_user:Les informations de lâutilisateur {0} ont Ã©tÃ© actualisÃ©es avec succÃšs.
+auth.success.delete_user:Utilisateur {0} supprimÃ© avec succÃšs.
+
 ## CrossCollectionSearch specific strings
 CrossCollectionSearch.TextQuery.name:Recherche multi-collection
Index: main/trunk/greenstone3/web/WEB-INF/classes/interface_default_fr.properties
===================================================================
--- main/trunk/greenstone3/web/WEB-INF/classes/interface_default_fr.properties	(revision 33114)
+++ main/trunk/greenstone3/web/WEB-INF/classes/interface_default_fr.properties	(revision 33115)
@@ -39,7 +39,23 @@
 debuginfo_tip:Afficher les options d'affichage de dÃ©bogage
 login_tip:S'identifier
+# months - used by replaceList in siteConfig. need to change to get from java..
+num:Nombre
+textmonth01:Janvier
+textmonth02:FÃ©vrier
+textmonth03:Mars
+textmonth04:Avril
+textmonth05:Mai
+textmonth06:Juin
+textmonth07:Juillet
+textmonth08:AoÃ»t
+textmonth09:Septembre
+textmonth10:Octobre
+textmonth11:Novembre
+textmonth12:DÃ©cembre
+
 aboutpage:Page Ã  propos
 home.quick_search:Recherche rapide
 home.librarian_interface:l'Interface BibliothÃ©caire
+home.gliapp_webstart:Application Web Start GLI Java
 home.select_a_collection:SÃ©lectionner une collection
 home.select_a_group:SÃ©lectionner un groupe de collections
@@ -141,5 +157,5 @@
 
 doc.map_nearby_docs:Afficher les documents prÃšs d'ici
-
+doc.nearby_doc_tooltip:Survolez pour centrer la carte sur ce document ; Cliquez pour aller au document.
 maps.scrolllabel:Faire dÃ©filer les lieux
 
@@ -162,5 +178,8 @@
 #  Document Editing #
 #####################
-
+de.error:Edition indisponible...
+de.error_unavailable:L'Ã©dition de documents n'est pas disponible pour le moment. Peut-Ãªtre que le dossier archives n'est pas prÃ©sent.
+de.error_wrong_group:Vous n'Ãªtes pas un membre du bon groupe pour avoir la permission d'Ã©diter cette collection.
+de.error_contact_admin:Veuillez contacter l'administrateur de votre bibliothÃšque ({0}).
 de.rebuilding_collection:reconstruction de la collection
 de.no_changes:Pas de modifications dÃ©tectÃ©es
@@ -172,7 +191,10 @@
 de.all_metadata:Tout
 de.add_new_metadata:Ajouter de nouvelles mÃ©tadonnÃ©es
+de.add_all_metadata:Ajouter tout
 de.no_meta_name_given:Aucune valeur donnÃ©e au nouveau nom de la mÃ©tadonnÃ©e
 de.edit_metadata:Ãditer les mÃ©tadonnÃ©es
+de.edit_map_gps:Modifier la carte GPS
 de.hide_metadata:masquer les mÃ©tadonnÃ©es
+de.hide_map_gps:Cacher la carte GPS
 de.remove:retirer
 de.edit_content:Ãditer le contenu
@@ -241,4 +263,20 @@
 db.no_collection_building:Vous ne pouvez pas utiliser cette fonctionnalitÃ© de Greenstone si vous n'activez pas la construction de la collection
 
+###################
+# Human Verification Page
+#######################
+
+verify.title:VÃ©rification
+verify.terms_title:Termes et conditions
+verify.terms_accept:J'accepte les termes et conditions
+
+###################
+# Error Page
+###################
+
+error.title:Oups ! Quelque chose a mal fonctionnÃ©.
+error.recap_fail:Recaptcha a Ã©chouÃ©.
+error.wrong_group:Vous n'Ãªtes pas dans le bon groupe pour consulter ce document.
+
 #####################
 #  Berry Baskets    #
@@ -266,2 +304,22 @@
 berry.send_success:Envoi du courrier rÃ©ussi
 berry.send_fail:Envoi du courrier a Ã©chouÃ©
+
+##################################
+# About Greenstone page
+##################################
+
+gsdl.title:A propos de Greenstone
+gsdl.brief:A propos du logiciel Greenstone
+gsdl.main:Greenstone est une suite de logiciels qui a la capacitÃ© de servir les collections des bibliothÃšques numÃ©riques et de crÃ©er de nouvelles collections. Il offre un moyen polyvalent d'organiser l'information et de la publier sur le Web ou sur des supports amovibles tels que DVD ou clÃ© USB. Greenstone est produit par le projet BibliothÃšque numÃ©rique de Nouvelle ZÃ©lande de l'UniversitÃ© de Waikato et distribuÃ© en coopÃ©ration avec l'UNESCO et l'ONG Human Info. Il s'agit d'un logiciel libre, disponible sur {0-link} sous les termes de la Licence Publique GÃ©nÃ©rale GNU.
+gsdl.technical:Technique
+gsdl.technical_desc:Voir la <a href="{0}">fiche d'information de greenstone</a> pour les dÃ©tails techniques tels que les versions, le support de la plate-forme et l'interopÃ©rabilitÃ©. Il existe deux versions majeures du logiciel : la version originale Greenstone 2, et Greenstone 3 qui est une refonte complÃšte et une rÃ©implÃ©mentation. Greenstone 3 est en dÃ©veloppement actif et son tÃ©lÃ©chargement est recommandÃ©. Cette page fait partie d'une installation de Greenstone 3.
+gsdl.customisation:Personnalisation
+gsdl.customisation_desc:Greenstone est spÃ©cialement conÃ§u pour Ãªtre hautement extensible et personnalisable. Les nouveaux formats de documents et de mÃ©tadonnÃ©es sont accommodÃ©s par l'Ã©criture de "plugins" (en Perl). De mÃªme, de nouvelles structures de navigation des mÃ©tadonnÃ©es peuvent Ãªtre implÃ©mentÃ©es en Ã©crivant des "classificateurs". L'interface utilisateur intuitive peut Ãªtre modifiÃ©e Ã  l'aide de modÃšles XSLT, CSS et Javascript. Le code source, en Java, C++, Perl et C++, est disponible et accessible pour modification. Pour plus d'informations, voir le wiki <a href="{0}">Greenstone wiki</a&gt ;.
+gsdl.documentation:Documentation
+gsdl.documentation_desc:Une documentation complÃšte sur le logiciel Greenstone est disponible sur le <a href="{0}">Wiki de Greenstone</a>, y compris des <a href="{1}">tutoriels</a&gt ; pas Ã  pas.
+gsdl.support:Support
+gsdl.support_desc:Voir la page <a href="{0}">support</a>pour plus de dÃ©tails sur les listes de diffusion spÃ©cifiques aux langues, les groupes de soutien rÃ©gionaux et autres ressources.
+gsdl.bugs:Bogues
+gsdl.bugs_desc:Nous voulons nous assurer que ce logiciel fonctionne bien pour vous. Veuillez rapporter tout bogue Ã  la <a href="{0}">liste de diffusion des utilisateurs de Greenstone</a>.
+gsdl.greenstone_stone:Greenstone est une pierre semi-prÃ©cieuse qui (comme ce logiciel) provient de Nouvelle-ZÃ©lande. Dans la sociÃ©tÃ© traditionnelle maorie, c'Ã©tait la substance la plus prisÃ©e et la plus recherchÃ©e de toutes. Elle peut absorber et retenir le wairua, qui est un esprit ou une force vitale, et est dotÃ©e de vertus traditionnelles qui en font un emblÃšme appropriÃ© pour un projet de bibliothÃšque numÃ©rique dans le domaine public. Son Ã©clat montre la charitÃ©, sa transluciditÃ©, son honnÃªtetÃ©, sa robustesse, son courage et l'arÃªte vive qu'il peut prendre, la justice.
+gsdl.toki_about2:Le toki doit symboliser l'importance du pounamu (pierre verte). C'est pour inspirer le travail qui se fait ici avec des qualitÃ©s de mana, d'autoritÃ© et de leadership. C'est une pierre dure, un lien Ã  Ã©tablir. Il doit Ãªtre utilisÃ© pour sculpter et guider l'excellence de la pensÃ©e qui est rÃ©coltÃ©e dans la BibliothÃšque numÃ©rique de Nouvelle ZÃ©lande.
Index: main/trunk/greenstone3/web/WEB-INF/classes/metadata_names_fr.properties
===================================================================
--- main/trunk/greenstone3/web/WEB-INF/classes/metadata_names_fr.properties	(revision 33114)
+++ main/trunk/greenstone3/web/WEB-INF/classes/metadata_names_fr.properties	(revision 33115)
@@ -1,4 +1,3 @@
 text:texte
-
 section\:text:le texte de la section
 document\:text:documents entiers
Index: main/trunk/release-kits/shared/core/language-strings/LanguagePack_fr.properties
===================================================================
--- main/trunk/release-kits/shared/core/language-strings/LanguagePack_fr.properties	(revision 33114)
+++ main/trunk/release-kits/shared/core/language-strings/LanguagePack_fr.properties	(revision 33115)
@@ -133,5 +133,5 @@
 ### Ant-Installer Core strings
 
-dirNotExistCreate:Ce rÃ©pertoire n'existe pas, souhaitez-vous le crÃ©er maintenant ?
+dirNotExistCreate:Ce rÃ©pertoire n'existe pas, souhaitez-vous le crÃ©er maintenant ? Y pour Oui ou N pour Non [par dÃ©fault\:N]
 dirNotExist:Ce rÃ©pertoire n'existe pas
 fileNotExist:Ce fichier n'existe pas