Index: other-projects/is-sheet-music-encore/trunk/COMPX520-DOWNLOADER-PNG.txt~
===================================================================
--- other-projects/is-sheet-music-encore/trunk/COMPX520-DOWNLOADER-PNG.txt~	(revision 33110)
+++ 	(revision )
@@ -1,11 +1,0 @@
-#!/bin/bash
-file_name=$1
-page_num=$2
-
-for id in `cat $file_name` ; do
-   
-    echo "id: $id  page_num: $page_num"
-    echo ""
-    ./RUN.sh $id $page_num
-  sleep 2  
-done
Index: other-projects/is-sheet-music-encore/trunk/COMPX520-DOWNLOADER-ZIP.txt~
===================================================================
--- other-projects/is-sheet-music-encore/trunk/COMPX520-DOWNLOADER-ZIP.txt~	(revision 33110)
+++ 	(revision )
@@ -1,11 +1,0 @@
-#!/bin/bash
-file_name=$1
-page_num=$2
-
-for id in `cat $file_name` ; do
-   
-    echo "id: $id  page_num: $page_num"
-    echo ""
-    ./RUN.sh $id $page_num
-  sleep 2  
-done
Index: other-projects/is-sheet-music-encore/trunk/COMPX520-RUN-NUMPAGES.sh~
===================================================================
--- other-projects/is-sheet-music-encore/trunk/COMPX520-RUN-NUMPAGES.sh~	(revision 33110)
+++ 	(revision )
@@ -1,16 +1,0 @@
-#!/bin/bash
-
-if [ $# != 1 ] ; then 
-  echo "Usage: ./COMPX520-RUN-NUMPAGES.sh doc_id" 1>&2
-  exit 1
-fi
-
-doc_id=$1
-
-output_file="download-numpages/$doc_id.txt"
-echo "Retrieving doc-id-page: $doc_id -> $output_file"
-echo ""
-
-./dapiclient2-extended-NUMPAGES.pl "$doc_id" > "$output_file"
-
-
Index: other-projects/is-sheet-music-encore/trunk/COMPX520-RUN-PAGENUM.sh~
===================================================================
--- other-projects/is-sheet-music-encore/trunk/COMPX520-RUN-PAGENUM.sh~	(revision 33110)
+++ 	(revision )
@@ -1,17 +1,0 @@
-#!/bin/bash
-
-if [ $# != 2 ] ; then 
-  echo "Usage: ./COMPX520-RUN-PAGENUM.sh doc_id page" 1>&2
-  exit 1
-fi
-
-doc_id=$1
-page_num=$2
-
-output_file="download-pagenum/$doc_id-$page_num.txt"
-echo "Retrieving doc-id-page: $doc_id-$page_num -> $output_file"
-echo ""
-
-./dapiclient2-extended-PAGENUM.pl "$doc_id/$page_num" > "$output_file"
-
-
Index: other-projects/is-sheet-music-encore/trunk/COMPX520-RUN-PNG.sh~
===================================================================
--- other-projects/is-sheet-music-encore/trunk/COMPX520-RUN-PNG.sh~	(revision 33110)
+++ 	(revision )
@@ -1,17 +1,0 @@
-#!/bin/bash
-
-if [ $# != 2 ] ; then 
-  echo "Usage: ./COMPX520-RUN-PNG.sh doc_id page" 1>&2
-  exit 1
-fi
-
-doc_id=$1
-page_num=$2
-
-output_file="download-images/page-$page_num/$doc_id-$page_num.png"
-echo "Retrieving doc-id-page: $doc_id-$page_num -> $output_file"
-echo ""
-
-./dapiclient2-extended.pl "$doc_id/$page_num" > "$output_file"
-
-
Index: other-projects/is-sheet-music-encore/trunk/COMPX520-RUN-ZIP.sh~
===================================================================
--- other-projects/is-sheet-music-encore/trunk/COMPX520-RUN-ZIP.sh~	(revision 33110)
+++ 	(revision )
@@ -1,16 +1,0 @@
-#!/bin/bash
-
-if [ $# != 1 ] ; then 
-  echo "Usage: ./RUN-ZIP.sh doc_id" 1>&2
-  exit 1
-fi
-
-doc_id=$1
-
-output_file="download-zips/$doc_id.zip"
-echo "Retrieving doc-id: $doc_id -> $output_file"
-echo ""
-
-./dapiclient2-extended-ZIP.pl "$doc_id" > "$output_file"
-
-
Index: other-projects/is-sheet-music-encore/trunk/my_access_key.txt~
===================================================================
--- other-projects/is-sheet-music-encore/trunk/my_access_key.txt~	(revision 33110)
+++ 	(revision )
@@ -1,1 +1,0 @@
-OAUTH_CONSUMER_KEY
Index: other-projects/is-sheet-music-encore/trunk/my_ip_address.txt~
===================================================================
--- other-projects/is-sheet-music-encore/trunk/my_ip_address.txt~	(revision 33110)
+++ 	(revision )
@@ -1,1 +1,0 @@
-MY_IP_ADDRESS
Index: other-projects/is-sheet-music-encore/trunk/my_secret_key.txt~
===================================================================
--- other-projects/is-sheet-music-encore/trunk/my_secret_key.txt~	(revision 33110)
+++ 	(revision )
@@ -1,1 +1,0 @@
-OAUTH_CONSUMER_SECRET