Index: main/trunk/greenstone3/web/interfaces/default/js/document_scripts.js
===================================================================
--- main/trunk/greenstone3/web/interfaces/default/js/document_scripts.js	(revision 33154)
+++ main/trunk/greenstone3/web/interfaces/default/js/document_scripts.js	(revision 33155)
@@ -1232,75 +1232,4 @@
 
 
-/***************
-* MENU SCRIPTS *
-***************/
-function moveScroller() {
-  var move = function() {
-    var editbar = $("#editBar");
-    var st = $(window).scrollTop();
-    var fa = $("#float-anchor").offset().top;
-    if(st > fa) {
-      
-      editbar.css({
-	  position: "fixed",
-	    top: "0px",
-	    width: editbar.data("width"),
-	    //width: "30%"
-            });
-    } else {
-      editbar.data("width", editbar.css("width"));
-      editbar.css({
-	  position: "relative",
-	    top: "",
-	    width: ""
-	    });
-    }
-  };
-  $(window).scroll(move);
-  move();
-}
-
-
-function floatMenu(enabled)
-{
-	var menu = $(".tableOfContentsContainer");
-	if(enabled)
-	{
-		menu.data("position", menu.css("position"));
-		menu.data("width", menu.css("width"));
-		menu.data("right", menu.css("right"));
-		menu.data("top", menu.css("top"));
-		menu.data("max-height", menu.css("max-height"));
-		menu.data("overflow", menu.css("overflow"));
-		menu.data("z-index", menu.css("z-index"));
-		
-		menu.css("position", "fixed");
-		menu.css("width", "300px");
-		menu.css("right", "0px");
-		menu.css("top", "100px");
-		menu.css("max-height", "600px");
-		menu.css("overflow", "auto");
-		menu.css("z-index", "200");
-		
-		$("#unfloatTOCButton").show();
-	}
-	else
-	{
-		menu.css("position", menu.data("position"));
-		menu.css("width", menu.data("width"));
-		menu.css("right", menu.data("right"));
-		menu.css("top", menu.data("top"));
-		menu.css("max-height", menu.data("max-height"));
-		menu.css("overflow", menu.data("overflow"));
-		menu.css("z-index", menu.data("z-index"));
-		
-		$("#unfloatTOCButton").hide();
-		$("#floatTOCToggle").prop("checked", false);
-	}
-	
-	var url = gs.xsltParams.library_name + "?a=d&ftoc=" + (enabled ? "1" : "0") + "&c=" + gs.cgiParams.c;
-	
-	$.ajax(url);
-}
 
 /********************
Index: main/trunk/greenstone3/web/interfaces/default/js/utility_scripts.js
===================================================================
--- main/trunk/greenstone3/web/interfaces/default/js/utility_scripts.js	(revision 33154)
+++ main/trunk/greenstone3/web/interfaces/default/js/utility_scripts.js	(revision 33155)
@@ -87,2 +87,74 @@
     return url_encoded;
 }
+
+/***************
+* MENU SCRIPTS *
+***************/
+function moveScroller() {
+  var move = function() {
+    var editbar = $("#editBar");
+    var st = $(window).scrollTop();
+    var fa = $("#float-anchor").offset().top;
+    if(st > fa) {
+      
+      editbar.css({
+	  position: "fixed",
+	    top: "0px",
+	    width: editbar.data("width"),
+	    //width: "30%"
+            });
+    } else {
+      editbar.data("width", editbar.css("width"));
+      editbar.css({
+	  position: "relative",
+	    top: "",
+	    width: ""
+	    });
+    }
+  };
+  $(window).scroll(move);
+  move();
+}
+
+
+function floatMenu(enabled)
+{
+	var menu = $(".tableOfContentsContainer");
+	if(enabled)
+	{
+		menu.data("position", menu.css("position"));
+		menu.data("width", menu.css("width"));
+		menu.data("right", menu.css("right"));
+		menu.data("top", menu.css("top"));
+		menu.data("max-height", menu.css("max-height"));
+		menu.data("overflow", menu.css("overflow"));
+		menu.data("z-index", menu.css("z-index"));
+		
+		menu.css("position", "fixed");
+		menu.css("width", "300px");
+		menu.css("right", "0px");
+		menu.css("top", "100px");
+		menu.css("max-height", "600px");
+		menu.css("overflow", "auto");
+		menu.css("z-index", "200");
+		
+		$("#unfloatTOCButton").show();
+	}
+	else
+	{
+		menu.css("position", menu.data("position"));
+		menu.css("width", menu.data("width"));
+		menu.css("right", menu.data("right"));
+		menu.css("top", menu.data("top"));
+		menu.css("max-height", menu.data("max-height"));
+		menu.css("overflow", menu.data("overflow"));
+		menu.css("z-index", menu.data("z-index"));
+		
+		$("#unfloatTOCButton").hide();
+		$("#floatTOCToggle").prop("checked", false);
+	}
+	
+	var url = gs.xsltParams.library_name + "?a=d&ftoc=" + (enabled ? "1" : "0") + "&c=" + gs.cgiParams.c;
+	
+	$.ajax(url);
+}